org.apache.commons.math3.linear

## Class AbstractFieldMatrix<T extends FieldElement<T>>

- java.lang.Object
- - org.apache.commons.math3.linear.AbstractFieldMatrix<T>

- Type Parameters:
    `T` - Type of the field elements.
  All Implemented Interfaces:
    AnyMatrix, FieldMatrix<T>
  Direct Known Subclasses:
    Array2DRowFieldMatrix, BlockFieldMatrix, SparseFieldMatrix

      public abstract class AbstractFieldMatrix<T extends FieldElement<T>>
      extends java.lang.Object
      implements FieldMatrix<T>

  Basic implementation of `FieldMatrix` methods regardless of the underlying storage.

  All the methods implemented here use `getEntry(int, int)` to access matrix elements. Derived class can provide faster implementations.

  Since:
    2.0
  Version:
    $Id: AbstractFieldMatrix.java 1416643 2012-12-03 19:37:14Z tn $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private Field<T>` | `field` Field to which the elements belong.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractFieldMatrix()` Constructor for use with Serializable
    `protected` | `AbstractFieldMatrix(Field<T> field)` Creates a matrix with no data
    `protected` | `AbstractFieldMatrix(Field<T> field, int rowDimension, int columnDimension)` Create a new FieldMatrix with the supplied row and column dimensions.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FieldMatrix<T>` | `add(FieldMatrix<T> m)` Compute the sum of this and m.
    `abstract void` | `addToEntry(int row, int column, T increment)` Change an entry in the specified row and column.
    `protected static <T extends FieldElement<T>> T[]` | `buildArray(Field<T> field, int length)` Build an array of elements.
    `protected static <T extends FieldElement<T>> T[][]` | `buildArray(Field<T> field, int rows, int columns)` Build an array of elements.
    `protected void` | `checkAdditionCompatible(FieldMatrix<T> m)` Check if a matrix is addition compatible with the instance.
    `protected void` | `checkColumnIndex(int column)` Check if a column index is valid.
    `protected void` | `checkMultiplicationCompatible(FieldMatrix<T> m)` Check if a matrix is multiplication compatible with the instance.
    `protected void` | `checkRowIndex(int row)` Check if a row index is valid.
    `protected void` | `checkSubMatrixIndex(int[] selectedRows, int[] selectedColumns)` Check if submatrix ranges indices are valid.
    `protected void` | `checkSubMatrixIndex(int startRow, int endRow, int startColumn, int endColumn)` Check if submatrix ranges indices are valid.
    `protected void` | `checkSubtractionCompatible(FieldMatrix<T> m)` Check if a matrix is subtraction compatible with the instance.
    `abstract FieldMatrix<T>` | `copy()` Make a (deep) copy of this.
    `void` | `copySubMatrix(int[] selectedRows, int[] selectedColumns, T[][] destination)` Copy a submatrix.
    `void` | `copySubMatrix(int startRow, int endRow, int startColumn, int endColumn, T[][] destination)` Copy a submatrix.
    `abstract FieldMatrix<T>` | `createMatrix(int rowDimension, int columnDimension)` Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
    `boolean` | `equals(java.lang.Object object)` Returns true iff `object` is a `FieldMatrix` instance with the same dimensions as this and all corresponding matrix entries are equal.
    `protected static <T extends FieldElement<T>> Field<T>` | `extractField(T[] d)` Get the elements type from an array.
    `protected static <T extends FieldElement<T>> Field<T>` | `extractField(T[][] d)` Get the elements type from an array.
    `T[]` | `getColumn(int column)` Get the entries in column number `col` as an array.
    `abstract int` | `getColumnDimension()` Returns the number of columns in the matrix.
    `FieldMatrix<T>` | `getColumnMatrix(int column)` Get the entries in column number `column` as a column matrix.
    `FieldVector<T>` | `getColumnVector(int column)` Returns the entries in column number `column` as a vector.
    `T[][]` | `getData()` Returns matrix entries as a two-dimensional array.
    `abstract T` | `getEntry(int row, int column)` Returns the entry in the specified row and column.
    `Field<T>` | `getField()` Get the type of field elements of the matrix.
    `T[]` | `getRow(int row)` Get the entries in row number `row` as an array.
    `abstract int` | `getRowDimension()` Returns the number of rows in the matrix.
    `FieldMatrix<T>` | `getRowMatrix(int row)` Get the entries in row number `row` as a row matrix.
    `FieldVector<T>` | `getRowVector(int row)` Get the entries in row number `row` as a vector.
    `FieldMatrix<T>` | `getSubMatrix(int[] selectedRows, int[] selectedColumns)` Get a submatrix.
    `FieldMatrix<T>` | `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Get a submatrix.
    `T` | `getTrace()` Returns the trace of the matrix (the sum of the elements on the main diagonal).
    `int` | `hashCode()` Computes a hashcode for the matrix.
    `boolean` | `isSquare()` Is this a square matrix?
    `FieldMatrix<T>` | `multiply(FieldMatrix<T> m)` Postmultiply this matrix by `m`.
    `abstract void` | `multiplyEntry(int row, int column, T factor)` Change an entry in the specified row and column.
    `FieldVector<T>` | `operate(FieldVector<T> v)` Returns the result of multiplying this by the vector `v`.
    `T[]` | `operate(T[] v)` Returns the result of multiplying this by the vector `v`.
    `FieldMatrix<T>` | `power(int p)` Returns the result multiplying this with itself `p` times.
    `FieldMatrix<T>` | `preMultiply(FieldMatrix<T> m)` Premultiply this matrix by `m`.
    `FieldVector<T>` | `preMultiply(FieldVector<T> v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `T[]` | `preMultiply(T[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `FieldMatrix<T>` | `scalarAdd(T d)` Increment each entry of this matrix.
    `FieldMatrix<T>` | `scalarMultiply(T d)` Multiply each entry by `d`.
    `void` | `setColumn(int column, T[] array)` Set the entries in column number `column` as a column matrix.
    `void` | `setColumnMatrix(int column, FieldMatrix<T> matrix)` Set the entries in column number `column` as a column matrix.
    `void` | `setColumnVector(int column, FieldVector<T> vector)` Set the entries in column number `column` as a vector.
    `abstract void` | `setEntry(int row, int column, T value)` Set the entry in the specified row and column.
    `void` | `setRow(int row, T[] array)` Set the entries in row number `row` as a row matrix.
    `void` | `setRowMatrix(int row, FieldMatrix<T> matrix)` Set the entries in row number `row` as a row matrix.
    `void` | `setRowVector(int row, FieldVector<T> vector)` Set the entries in row number `row` as a vector.
    `void` | `setSubMatrix(T[][] subMatrix, int row, int column)` Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array.
    `FieldMatrix<T>` | `subtract(FieldMatrix<T> m)` Subtract `m` from this matrix.
    `java.lang.String` | `toString()` Get a string representation for this matrix.
    `FieldMatrix<T>` | `transpose()` Returns the transpose of this matrix.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in column order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field

          private final Field<T extends FieldElement<T>> field

      Field to which the elements belong.

  - ### Constructor Detail

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix()

      Constructor for use with Serializable

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix(Field<T> field)

      Creates a matrix with no data
      Parameters:
        `field` - field to which the elements belong

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix(Field<T> field,
                             int rowDimension,
                             int columnDimension)
                                 throws NotStrictlyPositiveException

      Create a new FieldMatrix with the supplied row and column dimensions.
      Parameters:
        `field` - Field to which the elements belong.
        `rowDimension` - Number of rows in the new matrix.
        `columnDimension` - Number of columns in the new matrix.
      Throws:
        `NotStrictlyPositiveException` - if row or column dimension is not positive.

  - ### Method Detail

    - #### extractField

          protected static <T extends FieldElement<T>> Field<T> extractField(T[][] d)
                                                                  throws NoDataException,
                                                                         NullArgumentException

      Get the elements type from an array.
      Type Parameters:
        `T` - Type of the field elements.
      Parameters:
        `d` - Data array.
      Returns:
        the field to which the array elements belong.
      Throws:
        `NullArgumentException` - if the array is `null`.
        `NoDataException` - if the array is empty.

    - #### extractField

          protected static <T extends FieldElement<T>> Field<T> extractField(T[] d)
                                                                  throws NoDataException

      Get the elements type from an array.
      Type Parameters:
        `T` - Type of the field elements.
      Parameters:
        `d` - Data array.
      Returns:
        the field to which the array elements belong.
      Throws:
        `NoDataException` - if array is empty.

    - #### buildArray

          protected static <T extends FieldElement<T>> T[][] buildArray(Field<T> field,
                                                     int rows,
                                                     int columns)

      Build an array of elements.

      Complete arrays are filled with field.getZero()

      Type Parameters:
        `T` - Type of the field elements
      Parameters:
        `field` - field to which array elements belong
        `rows` - number of rows
        `columns` - number of columns (may be negative to build partial arrays in the same way `new Field[rows][]` works)
      Returns:
        a new array

    - #### buildArray

          protected static <T extends FieldElement<T>> T[] buildArray(Field<T> field,
                                                   int length)

      Build an array of elements.

      Arrays are filled with field.getZero()

      Type Parameters:
        `T` - the type of the field elements
      Parameters:
        `field` - field to which array elements belong
        `length` - of the array
      Returns:
        a new array

    - #### getField

          public Field<T> getField()

      Get the type of field elements of the matrix.
      Specified by:
        `getField` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        the type of field elements of the matrix.

    - #### createMatrix

          public abstract FieldMatrix<T> createMatrix(int rowDimension,
                                    int columnDimension)
                                                                       throws NotStrictlyPositiveException

      Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
      Specified by:
        `createMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `rowDimension` - the number of rows in the new matrix
        `columnDimension` - the number of columns in the new matrix
      Returns:
        a new matrix of the same type as the instance
      Throws:
        `NotStrictlyPositiveException` - if row or column dimension is not positive.

    - #### copy

          public abstract FieldMatrix<T> copy()

      Make a (deep) copy of this.
      Specified by:
        `copy` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        a copy of this matrix.

    - #### add

          public FieldMatrix<T> add(FieldMatrix<T> m)
                                                     throws MatrixDimensionMismatchException

      Compute the sum of this and m.
      Specified by:
        `add` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - Matrix to be added.
      Returns:
        `this` + `m`.
      Throws:
        `MatrixDimensionMismatchException` - if `m` is not the same size as `this` matrix.

    - #### subtract

          public FieldMatrix<T> subtract(FieldMatrix<T> m)
                                                          throws MatrixDimensionMismatchException

      Subtract `m` from this matrix.
      Specified by:
        `subtract` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - Matrix to be subtracted.
      Returns:
        `this` - `m`.
      Throws:
        `MatrixDimensionMismatchException` - if `m` is not the same size as `this` matrix.

    - #### scalarAdd

          public FieldMatrix<T> scalarAdd(T d)

      Increment each entry of this matrix.
      Specified by:
        `scalarAdd` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `d` - Value to be added to each entry.
      Returns:
        `d` + `this`.

    - #### scalarMultiply

          public FieldMatrix<T> scalarMultiply(T d)

      Multiply each entry by `d`.
      Specified by:
        `scalarMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `d` - Value to multiply all entries by.
      Returns:
        `d` * `this`.

    - #### multiply

          public FieldMatrix<T> multiply(FieldMatrix<T> m)
                                                          throws DimensionMismatchException

      Postmultiply this matrix by `m`.
      Specified by:
        `multiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - Matrix to postmultiply by.
      Returns:
        `this` * `m`.
      Throws:
        `DimensionMismatchException` - if the number of columns of `this` matrix is not equal to the number of rows of matrix `m`.

    - #### preMultiply

          public FieldMatrix<T> preMultiply(FieldMatrix<T> m)
                                                             throws DimensionMismatchException

      Premultiply this matrix by `m`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - Matrix to premultiply by.
      Returns:
        `m` * `this`.
      Throws:
        `DimensionMismatchException` - if the number of columns of `m` differs from the number of rows of `this` matrix.

    - #### power

          public FieldMatrix<T> power(int p)
                                                       throws NonSquareMatrixException,
                                                              NotPositiveException

      Returns the result multiplying this with itself `p` times. Depending on the type of the field elements, T, instability for high powers might occur.
      Specified by:
        `power` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `p` - raise this to power p
      Returns:
        this^p
      Throws:
        `NonSquareMatrixException` - if `this matrix` is not square
        `NotPositiveException` - if `p < 0`

    - #### getData

          public T[][] getData()

      Returns matrix entries as a two-dimensional array.
      Specified by:
        `getData` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        a 2-dimensional array of entries.

    - #### getSubMatrix

          public FieldMatrix<T> getSubMatrix(int startRow,
                                    int endRow,
                                    int startColumn,
                                    int endColumn)
                                                              throws NumberIsTooSmallException,
                                                                     OutOfRangeException

      Get a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Specified by:
        `getSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the matrix containing the data of the specified rows and columns.
      Throws:
        `NumberIsTooSmallException` - is `endRow < startRow` of `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.

    - #### getSubMatrix

          public FieldMatrix<T> getSubMatrix(int[] selectedRows,
                                    int[] selectedColumns)
                                                              throws NoDataException,
                                                                     NullArgumentException,
                                                                     OutOfRangeException

      Get a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Specified by:
        `getSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
      Returns:
        the matrix containing the data in the specified rows and columns.
      Throws:
        `NoDataException` - if `selectedRows` or `selectedColumns` is empty
        `NullArgumentException` - if `selectedRows` or `selectedColumns` is `null`.
        `OutOfRangeException` - if row or column selections are not valid.

    - #### copySubMatrix

          public void copySubMatrix(int startRow,
                           int endRow,
                           int startColumn,
                           int endColumn,
                           T[][] destination)
                             throws MatrixDimensionMismatchException,
                                    NumberIsTooSmallException,
                                    OutOfRangeException

      Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Specified by:
        `copySubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `startRow` - Initial row index.
        `endRow` - Final row index (inclusive).
        `startColumn` - Initial column index.
        `endColumn` - Final column index (inclusive).
        `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used).
      Throws:
        `MatrixDimensionMismatchException` - if the dimensions of `destination` do not match those of `this`.
        `NumberIsTooSmallException` - is `endRow < startRow` of `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.

    - #### copySubMatrix

          public void copySubMatrix(int[] selectedRows,
                           int[] selectedColumns,
                           T[][] destination)
                             throws MatrixDimensionMismatchException,
                                    NoDataException,
                                    NullArgumentException,
                                    OutOfRangeException

      Copy a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Specified by:
        `copySubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
        `destination` - Arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
      Throws:
        `MatrixDimensionMismatchException` - if the dimensions of `destination` do not match those of `this`.
        `NoDataException` - if `selectedRows` or `selectedColumns` is empty
        `NullArgumentException` - if `selectedRows` or `selectedColumns` is `null`.
        `OutOfRangeException` - if the indices are not valid.

    - #### setSubMatrix

          public void setSubMatrix(T[][] subMatrix,
                          int row,
                          int column)
                            throws DimensionMismatchException,
                                   OutOfRangeException,
                                   NoDataException,
                                   NullArgumentException

      Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array. Indexes are 0-based.

      Example:
      Starting with

           1  2  3  4
           5  6  7  8
           9  0  1  2

      and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

           1  2  3  4
           5  3  4  8
           9  5  6  2

      Specified by:
        `setSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `subMatrix` - Array containing the submatrix replacement data.
        `row` - Row coordinate of the top-left element to be replaced.
        `column` - Column coordinate of the top-left element to be replaced.
      Throws:
        `DimensionMismatchException` - if `subMatrix` is not rectangular (not all rows have the same length).
        `OutOfRangeException` - if `subMatrix` does not fit into this matrix from element in `(row, column)`.
        `NoDataException` - if a row or column of `subMatrix` is empty.
        `NullArgumentException` - if `subMatrix` is `null`.

    - #### getRowMatrix

          public FieldMatrix<T> getRowMatrix(int row)
                                                              throws OutOfRangeException

      Get the entries in row number `row` as a row matrix.
      Specified by:
        `getRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be fetched.
      Returns:
        a row matrix.
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.

    - #### setRowMatrix

          public void setRowMatrix(int row,
                          FieldMatrix<T> matrix)
                            throws OutOfRangeException,
                                   MatrixDimensionMismatchException

      Set the entries in row number `row` as a row matrix.
      Specified by:
        `setRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be set.
        `matrix` - Row matrix (must have one row and the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance row.

    - #### getColumnMatrix

          public FieldMatrix<T> getColumnMatrix(int column)
                                                                 throws OutOfRangeException

      Get the entries in column number `column` as a column matrix.
      Specified by:
        `getColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - Column to be fetched.
      Returns:
        a column matrix.
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.

    - #### setColumnMatrix

          public void setColumnMatrix(int column,
                             FieldMatrix<T> matrix)
                               throws OutOfRangeException,
                                      MatrixDimensionMismatchException

      Set the entries in column number `column` as a column matrix.
      Specified by:
        `setColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - Column to be set.
        `matrix` - column matrix (must have one column and the same number of rows as the instance).
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance column.

    - #### getRowVector

          public FieldVector<T> getRowVector(int row)
                                                              throws OutOfRangeException

      Get the entries in row number `row` as a vector.
      Specified by:
        `getRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be fetched
      Returns:
        a row vector.
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.

    - #### setRowVector

          public void setRowVector(int row,
                          FieldVector<T> vector)
                            throws OutOfRangeException,
                                   MatrixDimensionMismatchException

      Set the entries in row number `row` as a vector.
      Specified by:
        `setRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be set.
        `vector` - row vector (must have the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the vector dimension does not match one instance row.

    - #### getColumnVector

          public FieldVector<T> getColumnVector(int column)
                                                                 throws OutOfRangeException

      Returns the entries in column number `column` as a vector.
      Specified by:
        `getColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - Column to be fetched.
      Returns:
        a column vector.
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.

    - #### setColumnVector

          public void setColumnVector(int column,
                             FieldVector<T> vector)
                               throws OutOfRangeException,
                                      MatrixDimensionMismatchException

      Set the entries in column number `column` as a vector.
      Specified by:
        `setColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - Column to be set.
        `vector` - Column vector (must have the same number of rows as the instance).
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the vector dimension does not match one instance column.

    - #### getRow

          public T[] getRow(int row)
                                             throws OutOfRangeException

      Get the entries in row number `row` as an array.
      Specified by:
        `getRow` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be fetched.
      Returns:
        array of entries in the row.
      Throws:
        `OutOfRangeException` - if the specified row index is not valid.

    - #### setRow

          public void setRow(int row,
                    T[] array)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

      Set the entries in row number `row` as a row matrix.
      Specified by:
        `setRow` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row to be set.
        `array` - Row matrix (must have the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the array size does not match one instance row.

    - #### getColumn

          public T[] getColumn(int column)
                                                throws OutOfRangeException

      Get the entries in column number `col` as an array.
      Specified by:
        `getColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be fetched
      Returns:
        array of entries in the column
      Throws:
        `OutOfRangeException` - if the specified column index is not valid.

    - #### setColumn

          public void setColumn(int column,
                       T[] array)
                         throws OutOfRangeException,
                                MatrixDimensionMismatchException

      Set the entries in column number `column` as a column matrix.
      Specified by:
        `setColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be set
        `array` - column array (must have the same number of rows as the instance)
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the array size does not match one instance column.

    - #### getEntry

          public abstract T getEntry(int row,
                   int column)
                                                      throws OutOfRangeException

      Returns the entry in the specified row and column.
      Specified by:
        `getEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be fetched
        `column` - column location of entry to be fetched
      Returns:
        matrix entry in row,column
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.

    - #### setEntry

          public abstract void setEntry(int row,
                      int column,
                      T value)
                                 throws OutOfRangeException

      Set the entry in the specified row and column.
      Specified by:
        `setEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be set
        `column` - column location of entry to be set
        `value` - matrix entry to be set in row,column
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.

    - #### addToEntry

          public abstract void addToEntry(int row,
                        int column,
                        T increment)
                                   throws OutOfRangeException

      Change an entry in the specified row and column.
      Specified by:
        `addToEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row location of entry to be set.
        `column` - Column location of entry to be set.
        `increment` - Value to add to the current matrix entry in `(row, column)`.
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.

    - #### multiplyEntry

          public abstract void multiplyEntry(int row,
                           int column,
                           T factor)
                                      throws OutOfRangeException

      Change an entry in the specified row and column.
      Specified by:
        `multiplyEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - Row location of entry to be set.
        `column` - Column location of entry to be set.
        `factor` - Multiplication factor for the current matrix entry in `(row,column)`
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.

    - #### transpose

          public FieldMatrix<T> transpose()

      Returns the transpose of this matrix.
      Specified by:
        `transpose` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        transpose matrix

    - #### isSquare

          public boolean isSquare()

      Is this a square matrix?
      Specified by:
        `isSquare` in interface `AnyMatrix`
      Returns:
        true if the matrix is square (rowDimension = columnDimension)

    - #### getRowDimension

          public abstract int getRowDimension()

      Returns the number of rows in the matrix.
      Specified by:
        `getRowDimension` in interface `AnyMatrix`
      Returns:
        rowDimension

    - #### getColumnDimension

          public abstract int getColumnDimension()

      Returns the number of columns in the matrix.
      Specified by:
        `getColumnDimension` in interface `AnyMatrix`
      Returns:
        columnDimension

    - #### getTrace

          public T getTrace()
                                             throws NonSquareMatrixException

      Returns the trace of the matrix (the sum of the elements on the main diagonal).
      Specified by:
        `getTrace` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        trace
      Throws:
        `NonSquareMatrixException` - if the matrix is not square.

    - #### operate

          public T[] operate(T[] v)
                                              throws DimensionMismatchException

      Returns the result of multiplying this by the vector `v`.
      Specified by:
        `operate` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the vector to operate on
      Returns:
        `this * v`
      Throws:
        `DimensionMismatchException` - if the number of columns of `this` matrix is not equal to the size of the vector `v`.

    - #### operate

          public FieldVector<T> operate(FieldVector<T> v)
                                                         throws DimensionMismatchException

      Returns the result of multiplying this by the vector `v`.
      Specified by:
        `operate` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the vector to operate on
      Returns:
        `this * v`
      Throws:
        `DimensionMismatchException` - if the number of columns of `this` matrix is not equal to the size of the vector `v`.

    - #### preMultiply

          public T[] preMultiply(T[] v)
                                                  throws DimensionMismatchException

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        `v * this`
      Throws:
        `DimensionMismatchException` - if the number of rows of `this` matrix is not equal to the size of the vector `v`

    - #### preMultiply

          public FieldVector<T> preMultiply(FieldVector<T> v)
                                                             throws DimensionMismatchException

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        `v * this`
      Throws:
        `DimensionMismatchException` - if the number of rows of `this` matrix is not equal to the size of the vector `v`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)
                                                   throws NumberIsTooSmallException,
                                                          OutOfRangeException

      Visit (and possibly change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)
                                                   throws NumberIsTooSmallException,
                                                          OutOfRangeException

      Visit (but don't change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                                                      throws NumberIsTooSmallException,
                                                             OutOfRangeException

      Visit (and possibly change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                                                      throws NumberIsTooSmallException,
                                                             OutOfRangeException

      Visit (but don't change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)
                                                         throws NumberIsTooSmallException,
                                                                OutOfRangeException

      Visit (and possibly change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)
                                                         throws NumberIsTooSmallException,
                                                                OutOfRangeException

      Visit (but don't change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`

    - #### toString

          public java.lang.String toString()

      Get a string representation for this matrix.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation for this matrix

    - #### equals

          public boolean equals(java.lang.Object object)

      Returns true iff `object` is a `FieldMatrix` instance with the same dimensions as this and all corresponding matrix entries are equal.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `object` - the object to test equality against.
      Returns:
        true if object equals this

    - #### hashCode

          public int hashCode()

      Computes a hashcode for the matrix.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        hashcode for matrix

    - #### checkRowIndex

          protected void checkRowIndex(int row)
                                throws OutOfRangeException

      Check if a row index is valid.
      Parameters:
        `row` - Row index to check.
      Throws:
        `OutOfRangeException` - if `index` is not valid.

    - #### checkColumnIndex

          protected void checkColumnIndex(int column)
                                   throws OutOfRangeException

      Check if a column index is valid.
      Parameters:
        `column` - Column index to check.
      Throws:
        `OutOfRangeException` - if `index` is not valid.

    - #### checkSubMatrixIndex

          protected void checkSubMatrixIndex(int startRow,
                                 int endRow,
                                 int startColumn,
                                 int endColumn)
                                      throws NumberIsTooSmallException,
                                             OutOfRangeException

      Check if submatrix ranges indices are valid. Rows and columns are indicated counting from 0 to n-1.
      Parameters:
        `startRow` - Initial row index.
        `endRow` - Final row index.
        `startColumn` - Initial column index.
        `endColumn` - Final column index.
      Throws:
        `OutOfRangeException` - if the indices are not valid.
        `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.

    - #### checkSubMatrixIndex

          protected void checkSubMatrixIndex(int[] selectedRows,
                                 int[] selectedColumns)
                                      throws NoDataException,
                                             NullArgumentException,
                                             OutOfRangeException

      Check if submatrix ranges indices are valid. Rows and columns are indicated counting from 0 to n-1.
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
      Throws:
        `NullArgumentException` - if the arrays are `null`.
        `NoDataException` - if the arrays have zero length.
        `OutOfRangeException` - if row or column selections are not valid.

    - #### checkAdditionCompatible

          protected void checkAdditionCompatible(FieldMatrix<T> m)
                                          throws MatrixDimensionMismatchException

      Check if a matrix is addition compatible with the instance.
      Parameters:
        `m` - Matrix to check.
      Throws:
        `MatrixDimensionMismatchException` - if the matrix is not addition-compatible with instance.

    - #### checkSubtractionCompatible

          protected void checkSubtractionCompatible(FieldMatrix<T> m)
                                             throws MatrixDimensionMismatchException

      Check if a matrix is subtraction compatible with the instance.
      Parameters:
        `m` - Matrix to check.
      Throws:
        `MatrixDimensionMismatchException` - if the matrix is not subtraction-compatible with instance.

    - #### checkMultiplicationCompatible

          protected void checkMultiplicationCompatible(FieldMatrix<T> m)
                                                throws DimensionMismatchException

      Check if a matrix is multiplication compatible with the instance.
      Parameters:
        `m` - Matrix to check.
      Throws:
        `DimensionMismatchException` - if the matrix is not multiplication-compatible with instance.

Copyright (c) 2003-2013 Apache Software Foundation